import windows;
import com;
alias IUnknown* LPUNKNOWN;


interface IDirectSoundCapture:IUnknown
{
    extern(Windows):
        HRESULT CreateCaptureBuffer(DSCBUFFERDESC *pcDSCBufferDesc, IDirectSoundCaptureBuffer**ppDSCBuffer, LPUNKNOWN pUnkOuter);
        HRESULT GetCaps(LPDSCCAPS pDSCCaps);
        HRESULT Initialize(LPCGUID pcGuidDevice);
}
interface IDirectSoundCaptureBuffer:IUnknown
{
    extern(Windows)
    {
        HRESULT GetCaps(LPDSCBCAPS pDSCBCaps);
        HRESULT GetCurrentPosition(LPDWORD pdwCapturePosition, LPDWORD pdwReadPosition);
        HRESULT GetFormat(LPWAVEFORMATEX pwfxFormat, DWORD dwSizeAllocated, LPDWORD pdwSizeWritten);
        HRESULT GetStatus(LPDWORD pdwStatus);
        HRESULT Initialize(LPDIRECTSOUNDCAPTURE pDirectSoundCapture, LPCDSCBUFFERDESC pcDSCBufferDesc);
        HRESULT Lock(DWORD dwOffset, DWORD dwBytes, LPVOID *ppvAudioPtr1, LPDWORD pdwAudioBytes1,LPVOID *ppvAudioPtr2, LPDWORD pdwAudioBytes2, DWORD dwFlags);
        HRESULT Start(DWORD dwFlags);
        void Stop();
        HRESULT Unlock (LPVOID pvAudioPtr1, DWORD dwAudioBytes1, LPVOID pvAudioPtr2, DWORD dwAudioBytes2);
    }
}
alias  IDirectSoundCapture    *   LPDIRECTSOUNDCAPTURE;
alias  IDirectSoundCaptureBuffer  *   LPDIRECTSOUNDCAPTUREBUFFER;
struct WAVEFORMATEX
{
    WORD  wFormatTag;
    WORD  nChannels;
    DWORD nSamplesPerSec;
    DWORD nAvgBytesPerSec;
    WORD  nBlockAlign;
    WORD  wBitsPerSample;
    WORD  cbSize;
} ;
alias WAVEFORMATEX* LPWAVEFORMATEX;

struct DSCBUFFERDESC
{
    DWORD           dwSize;
    DWORD           dwFlags;
    DWORD           dwBufferBytes;
    DWORD           dwReserved;
    WAVEFORMATEX*  lpwfxFormat;

    DWORD           dwFXCount;
    LPDSCEFFECTDESC lpDSCFXDesc;

} ;
alias DSCBUFFERDESC *LPDSCBUFFERDESC;
alias const DSCBUFFERDESC *LPCDSCBUFFERDESC;

struct DSCCAPS
{
    DWORD           dwSize;
    DWORD           dwFlags;
    DWORD           dwFormats;
    DWORD           dwChannels;
} ;
alias DSCCAPS *LPDSCCAPS;
alias const DSCCAPS *LPCDSCCAPS;

alias GUID * LPGUID;
alias const GUID *LPCGUID;
 struct DSCBCAPS
{
    DWORD           dwSize;
    DWORD           dwFlags;
    DWORD           dwBufferBytes;
    DWORD           dwReserved;
} ;
alias DSCBCAPS *LPDSCBCAPS;
alias const DSCBCAPS *LPCDSCBCAPS;

struct DSCEFFECTDESC
{
    DWORD       dwSize;
    DWORD       dwFlags;
    GUID        guidDSCFXClass;
    GUID        guidDSCFXInstance;
    DWORD       dwReserved1;
    DWORD       dwReserved2;
} ;
alias DSCEFFECTDESC *LPDSCEFFECTDESC;
alias const DSCEFFECTDESC *LPCDSCEFFECTDESC;
enum
{
    WAVE_FORMAT_PCM    =   1 ,
}
WAVEFORMATEX WFX={WAVE_FORMAT_PCM,1,22050,44100,2,16,WAVEFORMATEX.size};

extern(Windows)
{
    export HRESULT  DirectSoundCaptureCreate(LPCGUID pcGuidDevice, IDirectSoundCapture**ppDSC, LPUNKNOWN pUnkOuter);
}

void main()
{
 	IDirectSoundCapture *      m_lpSoundCard;
	IDirectSoundCaptureBuffer* m_pDSBCapture;

    HRESULT HR;
    HR = CoInitializeEx(null,0);

    HR=DirectSoundCaptureCreate((LPCGUID)null,&m_lpSoundCard,(LPUNKNOWN)null);
    if(HR!=S_OK)
        printf("DirectSoundCaptureCreate Failed \n");
    DSCBUFFERDESC dscdb;
    ZeroMemory( &dscdb, DSCBUFFERDESC.size );
	dscdb.dwSize=DSCBUFFERDESC.size;
	dscdb.dwBufferBytes=4096;
	dscdb.lpwfxFormat=&WFX;

	//Create the sound capture buffer
	HR=m_lpSoundCard.CreateCaptureBuffer(&dscdb,&m_pDSBCapture,(IUnknown *)null);
    if(HR!=S_OK)
        printf("CreateCaptureBuffer failed\n");
}
import string;
void ZeroMemory(void* dest, uint len)
{
	memset(dest, 0, len);
}